// Chimères Orchestra
// Pd > Serial > Arduino MEGA > MOSFETS

#include "PwmMotor.h"

// ---- CONFIGURATIONS ---- //
int pins[] = {3,5,6,9,10,11};
int time_max = 150;
boolean DEBUG = false;

// ---- VARIABLES --------- //
int id, pwm, time;
const int nb = 6;
PwmMotor motors[nb];
unsigned long current = 0;

// ---- PROGRAM ----------- //
void setup() {
  Serial.begin(38400);
   for (int i; i < nb; i++) {
     motors[i].init(pins[i], time_max, DEBUG);
  }
}

void loop() {
  current = millis();
  
  // ON
  while (Serial.available()) {
     id = Serial.parseInt(); 
     pwm = Serial.parseInt();
     time = Serial.parseInt();
     if (Serial.read() == '\n') {
       if( !motors[id].isOn() )  motors[id].on(current, pwm, time);
     }
   }
  
  // OFF
  for (int i; i < nb; i++) {
     if( motors[i].isOn() ) motors[i].off(current);
  }
  
  delay(1);
}
